## percona-server-mongodb 4.4.16

=== SConstruct ===
--- 
+++ 
@@ -30,6 +30,7 @@
 import mongo.toolchain as mongo_toolchain
 import mongo.generators as mongo_generators
 import mongo.install_actions as install_actions
+from mongo.build_profiles import BUILD_PROFILES
 
 EnsurePythonVersion(3, 6)
 EnsureSConsVersion(3, 1, 1)
@@ -105,9 +106,23 @@
 #   using the nargs='const' mechanism.
 #
 
-add_option('ninja',
+add_option(
+    'build-profile',
+    choices=list(BUILD_PROFILES.keys()),
+    default='default',
+    type='choice',
+    help='''Short hand for common build options. These profiles are well supported by SDP and are 
+    kept up to date. Unless you need something specific, it is recommended that you only build with 
+    these. san is the recommeneded profile since it exposes bugs before they are found in patch 
+    builds. Check out site_scons/mongo/build_profiles.py to see each profile.''',
+)
+
+build_profile = BUILD_PROFILES[get_option('build-profile')]
+
+add_option(
+    'ninja',
     choices=['enabled', 'disabled'],
-    default='disabled',
+    default=build_profile.ninja,
     nargs='?',
     const='enabled',
     type='choice',
@@ -273,7 +288,7 @@
 add_option('dbg',
     choices=['on', 'off'],
     const='on',
-    default='off',
+    default=build_profile.dbg,
     help='Enable runtime debugging checks',
     nargs='?',
     type='choice',
@@ -308,6 +323,7 @@
 add_option('sanitize',
     help='enable selected sanitizers',
     metavar='san1,san2,...sanN',
+    default=build_profile.sanitize,
 )
 
 add_option('sanitize-coverage',
@@ -322,7 +338,7 @@
 
 add_option('allocator',
     choices=["auto", "system", "tcmalloc", "tcmalloc-experimental"],
-    default="auto",
+    default=build_profile.allocator,
     help='allocator to use (use "auto" for best choice for current platform)',
     type='choice',
 )
@@ -463,31 +479,3 @@
     const='all',
     help='Use an object cache rather than a per-build variant directory (experimental)',
     nargs='?',
-)
-
-add_option('cache-dir',
-    default='$BUILD_ROOT/scons/cache',
-    help='Specify the directory to use for caching objects if --cache is in use',
-)
-
-add_option("cxx-std",
-    choices=["17"],
-    default="17",
-    help="Select the C++ langauge standard to build with",
-)
-
-def find_mongo_custom_variables():
-    files = []
-    paths = [path for path in sys.path if 'site_scons' in path]
-    for path in paths:
-        probe = os.path.join(path, 'mongo_custom_variables.py')
-        if os.path.isfile(probe):
-            files.append(probe)
-    return files
-
-add_option('variables-files',
-    default=[],
-    action="append",
-    help="Specify variables files to load.",
-)
-
