## percona-server-mongodb 4.4.17

=== SConstruct ===
--- 
+++ 
@@ -313,8 +313,9 @@
 )
 
 add_option('opt',
-    choices=['on', 'size', 'off'],
-    const='on',
+    choices=['on', 'size', 'off', 'auto'],
+    const='on',
+    default=build_profile.opt,
     help='Enable compile-time optimization',
     nargs='?',
     type='choice',
@@ -477,5 +478,3 @@
 add_option('cache',
     choices=["all", "nolinked"],
     const='all',
-    help='Use an object cache rather than a per-build variant directory (experimental)',
-    nargs='?',
